<?php

namespace Gogs\Lib {

    class Collection implements ArrayIterator {
        private $objs = array();

        public function set($val, $key = null) {
            if ($key == null && is_array($val))
                $this->objs = $val;
            else if ($key != null)
                $this->objs[$key] = $val;
            else 
                array_push($this->objs, $val);
        }

        public function by_key($idx) {
            return isset($this->objs[$idx]) ? $this->objs[$idx] : false;
        }

        public function all() {
            return $this->objs;
        }

        public function len() {
            return count($this->objs);
        }

        public function next() {
            return next($this->objs);
        }

        public function current() {
            return current($this->objs);
        }

        public function reset() {
            return reset($this->objs);
        }

    }

}
